<?php
require_once (_PS_MODULE_DIR_ . 'eurosms/classes/AdminEuroSmsController.php');
require_once (_PS_MODULE_DIR_ . 'eurosms/classes/model/EuroSmsHistory.php');
require_once (_PS_MODULE_DIR_ . 'eurosms/classes/model/EuroSmsConfiguration.php');
class AdminEuroSmsHistoryController extends AdminEuroSmsController {

  const ITEMS_PER_PAGE = 100;

  function __construct() {
    parent::__construct();

    $this->className = 'EuroSmsHistory';
    $this->meta_title = $this->l('SMS History');
    $this->toolbar_title = $this->l('SMS History');

    global $eurosms;
    $eurosms->registerCronHandler(__FILE__, 'AdminEuroSmsHistoryController', 'esProcessStatus');
  }

  protected function getFilter() {
    $filter = Tools::isSubmit('filter');

    if ($filter) {
      $timestamp = Tools::getValue('timestamp');
      $sender = Tools::getValue('sender');
      $recipient = Tools::getValue('recipient');
      $text = Tools::getValue('text');
      $status = Tools::getValue('status');
      $type = Tools::getValue('type');
      $simulation = Tools::getValue('simulation');
      $filterData = array(
        'timestamp' => $timestamp,
        'status' => $status,
        'type' => $type,
        'simulation' => $simulation,
        'sender' => $sender,
        'recipient' => $recipient,
        'text' => $text
      );
    }
    else {
      $filterData = array('simulation' => 0);
    }

    return $filterData;
  }

  public static function esProcessStatus() {
    $config = new EuroSmsConfiguration();
    if ($config->delivery_reports) {
      $histories = EuroSmsHistory::loadHistory(array('status' => array('sent', 'pending', 'delivered')));
      EuroSmsHistory::checkStatuses($histories);
    }
  }

  protected function setDefaultVars() {
    if (!Tools::getValue('filter')) {
      $this->tpl_view_vars['request']['simulation'] = 0;
      $this->tpl_view_vars['request']['type'] = array(
        'sending',
        'marketing',
        'notification'
      );
    }
  }

  public function postProcess() {
    $filterData = $this->getFilter();
    $page = (int)Tools::getValue('page');
    if (!$page) {
      $page = 1;
    }

    $total = 0;
    $history = EuroSmsHistory::getHistory($filterData, static::ITEMS_PER_PAGE, $page, $total);

    $this->tpl_view_vars['history'] = $history;
    $this->tpl_view_vars['total'] = $total;
    //$this->tpl_view_vars['total'] = 1000;
    $this->tpl_view_vars['page'] = $page;
    $this->tpl_view_vars['per_page'] = static::ITEMS_PER_PAGE;

    $this->setDefaultVars();
  }
}
