<?php
require_once (_PS_MODULE_DIR_ . 'eurosms/classes/AdminEuroSmsController.php');
require_once (_PS_MODULE_DIR_ . 'eurosms/classes/model/EuroSmsRecipientFilter.php');
class AdminEuroSmsSendingController extends AdminEuroSmsController {
  protected static $allowedTokens = array('customer', 'shop');

  function __construct() {
    parent::__construct();

    require_once (_PS_MODULE_DIR_ . 'eurosms/classes/model/EuroSmsSending.php');

    $this->className = 'EuroSmsSending';
    $this->meta_title = $this->l('SMS Sending');
    $this->toolbar_title = $this->l('SMS Sending');
  }

  public function renderView() {
    $customers = EuroSmsRecipientFilter::getRecipients();
    $this->tpl_view_vars['customers'] = $customers;

    $customer_list = array();
    foreach ($customers as $customer) {
      $alpha = @$customer['lastname'][0];
      if (!$alpha) {
        $alpha = @$customer['firstname'][0];
      }

      if ($alpha) {
        $alpha = strtoupper($alpha);
        $customer_list[$alpha][$customer['id_customer']] = $customer;
      }
    }

    ksort($customer_list);
    $this->tpl_view_vars['customer_list'] = $customer_list;

    return parent::renderView();
  }

  protected function saveData($sending, $type = EuroSmsHistory::TYPE_SENDING) {
    $sending->esSetFromRequest();
    $sending->type = $type;
    //var_dump($_REQUEST); die();
    //var_dump($sending); die();

    $notification = new EuroSmsNotification();
    $notification->esSetFromRequest();
    $sending->notification = $notification;

    return $this->esSaveModel($sending, $this->l($sending->template ? 'Template saved' : 'Message sent.'));
  }

  public function postProcess() {
    $send = Tools::isSubmit('send');

    if ($send) {
      $id = Tools::getValue('id');
      $sending = $this->esLoadModel($id);
      $this->saveData($sending);
    }
  }

  protected function esProcessAjax($ajaxCmd) {
    switch ($ajaxCmd) {
      case 'templateLoad':
        $templates = EuroSmsSending::getTemplates();
        return $templates;
      break;

      case 'templateSave':
        $sending = $this->esLoadModel();
        $return = $this->saveData($sending);
        if ($return) {
          return 0;
        }
        else {
          return html_entity_decode(reset($this->errors));
        }
      break;

      case 'templateDelete':
        $id = Tools::getValue('id');
        if ($id) {
          $notification = new EuroSmsNotification($id);
          if ($this->esDeleteModel($notification, $this->l('Template deleted.'))) {
            return 0;
          }
          else {
            return html_entity_decode(reset($this->errors));
          }
        }
      break;

      default:
        return parent::esProcessAjax($ajaxCmd);
    }
  }
}
