jQuery(document).on('keyup keypress', '.pstaggerAddTagInput', function(e) {
    if (e.keyCode == 13) {
        e.preventDefault();
        return false;
    }
});

jQuery(document).ready(function() {
    var EUROSMS_DEFAULT_MESSAGE_LENGTH = 160;
    var EUROSMS_DEFAULT_NEXT_MESSAGE_LENGTH = 153;
    var EUROSMS_UNICODE_MESSAGE_LENGTH = 70;
    var EUROSMS_UNICODE_NEXT_MESSAGE_LENGTH = 67;

    if (jQuery('section.eurosms').length) {
        jQuery('body').addClass('eurosmsAdmin');
    }

    var pstaggerApply;
    $('.eurosms .pstagger-bar:not([data-es-noapply]').each(pstaggerApply = function() {
        var $this = jQuery(this);
        var delimiter = $this.attr('data-es-delimiter') || ',';
        var noedit = $this.is('[data-es-noedit]');
        var placeholder = $this.attr('placeholder') || '--- None ---';

        var $input = $this;
        $this.pstagger({
            inputPlaceholder: placeholder,
            delimiter: delimiter,
            clearAllBtn: true,
            onTagsChanged: function() {
                $input.val($tagInput.val().trim()).trigger('change');
            },

            onResetTags: function() {
                $input.val($tagInput.val().trim()).trigger('change');
            }
        });

        var val = $this.val();

        var $tagInput = $this.parent().find('.pstaggerAddTagInput');
        if (noedit) {
            $tagInput.bind('focus', function() {
                var $this = jQuery(this);
                $this.blur();
            });
        }

        var inputName = $this.attr('name');
        if (inputName) {
            $tagInput.attr('name', 'tagger[' + inputName + ']');
        }
        /*jQuery('form').submit(function(evt) {
            if (evt.target == $tagInput[0]) {
                evt.preventDefault();
            }
        });*/

        if ($this.attr('required')) {
            $tagInput.attr('required', 1).prop('required', 1);
        }

        var format = $this.attr('data-es-format');

        $tagInput.val($this.val()).on('change mousedown', function() {
            var $this = jQuery(this);
            var val = $this.val();
            if (val) {
                var valSplit = val.split(delimiter);
                for (var i = 0; i < valSplit.length; i++) {
                    switch (format) {
                        case 'phone':
                            valSplit[i] = esFormatPhoneNumber(valSplit[i]);
                            break;
                    }
                }

                val = valSplit.join(delimiter);
                $this.val(val.trim());
            }

            $this.trigger('focusout');
        }).trigger('change');
    });

    var selectedLanguage;
    var $langLabels = jQuery('.eurosms [name^="language"][data-es-language] + label').click(function() {
        var $this = jQuery(this);
        if ($this.is('label')) {
            $this = $this.prev();
        }

        var lang = $this.attr('data-es-language');
        selectedLanguage = lang;
        if ($this.is('[type="radio"]')) {
            var root = $this.closest('.row [data-id], .row [data-for]');
            if (!root.length) {
                root = document;
            }

            jQuery('[data-es-language]:not([type="radio"])', root).each(function() {
                var $this = jQuery(this);
                $this.hide();
                if ($this.is('input[type="text"], textarea') && !$this.val()) {
                    var name = $this.attr('name');
                    var nameSplit = name.split('[');
                    nameSplit.pop();
                    var namePrefix = nameSplit.join('[');
                    var $def = jQuery('[data-es-default^="' + namePrefix + '"]', root);
                    if ($def.length) {
                        $this.val($def.val()).trigger('change');
                    }
                }
            });

            //if ($this.is(':checked')) {
            jQuery('[data-es-language="' + lang + '"]:not([type="radio"])', root).show();
            //}
        }
    });

    $langLabels.filter('.ps-switch *:nth-child(2)').each(function() {
        jQuery(this).trigger('click');
    });

    $langLabels.closest('form').find('[type="submit"]').on('mousedown touchstart', function() {
        $langLabels.each(function() {
            var $this = jQuery(this);
            $this.triggerHandler('click');
        });

        $langLabels.eq(0).triggerHandler('click');
    });

    function esReplaceTokens(source) {
        if (!window.euroSmsTokens) {
            return source;
        }

        var target = source;
        for (var i in window.euroSmsTokens) {
            var token = window.euroSmsTokens[i];
            var tokenSplit = i.split('_');
            var tokenPrefix = tokenSplit.shift();
            var $token = jQuery('.eurosms [data-es-token="' + tokenPrefix + '"]');
            var tokenText = token.text;
            if ($token.length) {
                var val;
                if ($token.is('select')) {
                    var $option = $token.find('option:selected');
                    val = $option.attr('data-value');
                    if (val == undefined) {
                        val = $option.val();
                    }
                } else {
                    val = $token.val();
                }

                if (val) {
                    var tokens = JSON.parse(val);
                    var tokenSuffix = tokenSplit.join('_');
                    if (tokens[tokenSuffix]) {
                        tokenText = tokens[tokenSuffix];
                    }
                }
            }

            target = target.replace(new RegExp(token.jsPattern, 'g'), tokenText);
        }

        return target;
    }

    function esTransliterate(source) {
        var target = source.replace(/[^\x00-\x7F]/g, '?');
        return target;
    }

    function esFormatPhoneNumber(phoneNumber) {
        try {
            var phoneParsed = libphonenumber.parse(phoneNumber, 'SK');
            return libphonenumber.format(phoneParsed, "International").split(' ').join('');
        } catch (e) {
            console.log(e);
            return phoneNumber;
        }
    }

    jQuery('.eurosms [data-es-type]').each(function() {
        var $this = jQuery(this);
        var type = $this.attr('data-es-type');
        var bindName = $this.attr('data-es-bind');
        var $binded;
        if (bindName) {
            $binded = jQuery('.eurosms [name="' + bindName + '"]');
        }

        switch (type) {

            case "charCount":
                $binded.on('change keyup', function() {
                    var val = $binded.val();
                    var len = val.length;
                    $this.val(len).text(len);
                });
                break;

            case "msgCount":
                var lang = $binded.attr('data-es-language');
                var countName = $this.attr('data-es-count');
                var $count = jQuery('.eurosms [name="' + countName + '"]');

                var name = bindName;
                var unicodeName = bindName.replace('preview', 'unicode');
                var $unicode = jQuery('.eurosms [name="' + unicodeName + '"]');

                var fnc;
                $binded.on('change keyup', fnc = function() {
                    $count = jQuery('.eurosms [name="' + countName + '"]:not([data-es-noapply])');
                    $count.off('change').on('change', fnc);


                    var val = $binded.val();
                    var msgLen = $unicode.is(':checked') ? EUROSMS_UNICODE_MESSAGE_LENGTH : EUROSMS_DEFAULT_MESSAGE_LENGTH;
                    var msgNextLen = $unicode.is(':checked') ? EUROSMS_UNICODE_NEXT_MESSAGE_LENGTH : EUROSMS_DEFAULT_NEXT_MESSAGE_LENGTH;
                    var textLen = val.length;
                    var msgCount = Math.ceil(Math.max(0, textLen - msgLen) / msgNextLen) + 1;
                    var countStr = msgCount;
                    if ($count.length) {
                        var totalCount = 0;
                        $count.each(function() {
                            var $this = jQuery(this);
                            var val = $this.val();
                            if (val) {
                                var delimiter = $this.attr('data-es-delimiter') || ',';
                                var valSplit = val.trim() ? val.trim().split(delimiter) : [];
                                totalCount += valSplit.length;
                            }
                        });

                        if (totalCount) {
                          countStr = msgCount + ' (' + (msgCount * totalCount) + ')';
                        }
                    }

                    $this.val(countStr).text(countStr);
                });

                $unicode.on('change', fnc);
                $count.on('change', fnc);

                break;
        }
    });

    jQuery('.eurosms [data-es-type]').on('click change keyup', function(evt) {
        //console.log(evt);
        //evt.preventDefault();
        evt.stopPropagation();
        if (jQuery(evt.target).is('a')) {
            evt.target.blur();
        }

        var $this = jQuery(this);
        var type = $this.attr('data-es-type');
        var bindName = $this.attr('data-es-bind');
        var $binded;
        if (bindName) {
            bindName = bindName.replace('%language%', selectedLanguage);
            $binded = jQuery('.eurosms [name="' + bindName + '"]');
        }

        switch (type) {
            case "reset":
                $binded.val('').trigger('change');
                break;

            case "text":
                var source = $binded.val();
                var start = $binded.prop("selectionStart");
                if (start == undefined) {
                    start = source.length - 1;
                }

                var text = $this.attr('data-value');
                var target = source.substring(0, start) /* + ' ' */ + text + /*' ' +*/ source.substring(start, source.length);
                $binded.val(target).trigger('change').focus();
                break;

            case "source":
                var source = $this.val();
                var target = esReplaceTokens(source);

                var name = $this.attr('name');
                var nameSplit = name.split('[');
                nameSplit.shift();
                name = 'unicode[' + nameSplit.join('[');
                var $unicode = jQuery('.eurosms [name="' + name + '"]');
                if (!$unicode.is(':checked')) {
                    target = esTransliterate(target);
                }

                $binded.val(target).trigger('change');
                break;

            case "charCount":
                var val = $binded.val();
                $this.val(val.length).text(val.length);
                break;

            case "msgCount":
                break;

            case 'toggle':
                var checked = $this.is(':checked');
                if (checked) {
                    $binded.show();
                } else {
                    $binded.hide();
                }

                break;


            case "tag":

                function esApplyTagValues(vals) {
                    var values = [];
                    for (var i = 0; i < vals.length; i++) {
                        var val = vals[i];
                        if (val && val.length && val.trim()) {
                            values.push(val.trim());
                        }
                    }

                    if (!values.length) {
                        return false;
                    }

                    var delimiter = $binded.attr('data-es-delimiter') || ',';
                    var valuesString = values.join(delimiter);
                    var $tagInput = $binded.parent().find('.pstaggerAddTagInput');
                    var tagVal = $tagInput.val();
                    var finalVal = tagVal + delimiter + valuesString;
                    var finalArr = finalVal.split(delimiter);
                    finalArr = finalArr.filter(function(value, index, self) {
                        return self.indexOf(value) === index;
                    });
                    $tagInput.val(finalArr.join(delimiter)).trigger('change');
                }

                if ($this.is('select') || $this.is('input:not([type="file"])')) {
                    var val = $this.val();
                    if (val) {
                        esApplyTagValues([$this.val()]);
                        $this.val('').trigger('change');
                    }
                } else if ($this.is('button')) {
                    esApplyTagValues([$this.attr('data-value')]);
                } else if ($this.is('[type="file"]')) {
                    if (evt.type == 'click') {
                        return;
                    }

                    var files = evt.target.files;
                    if (!files[0]) {
                        return false;
                    }

                    var reader = new FileReader();
                    reader.onload = function(evt) {
                        var lines = evt.target.result;
                        var linesSplit = lines.split('\n');
                        var values = [];
                        for (var i = 0; i < linesSplit.length; i++) {
                            var line = linesSplit[i];
                            line = line.trim();
                            if (line) {
                                values.push(line);
                            }
                        }
                        esApplyTagValues(values);
                    }

                    reader.readAsText(files[0]);
                    $this.val('');
                }
                break;
        }

        return false;
    });

    jQuery('.eurosms [data-es-type="toggle"], .eurosms [data-es-type="source"]').trigger('change');

    jQuery(".eurosms [data-es-object]").has('[data-es-action]').each(function() {
        var $editingEntry;

        var $this = jQuery(this);
        var objectName = $this.attr('data-es-object');

        var addFnc;
        var $add = $this.find("[data-es-action='add']");
        $add.bind('click.add', addFnc = function(evt) {
            var $this = jQuery(this);
            var $tpl = jQuery('.eurosms [data-es-entry="' + objectName + '"].template');
            var $clone = $tpl.clone();
            $clone.removeClass('template');

            $editingEntry = $clone;
            saveFnc(evt);
            //$save.click();

            if (!$clone.attr('data-es-invalid')) {
                $clone.appendTo($tpl.parent());
            }

            $save.hide();
        });

        jQuery('.eurosms [data-es-entry="' + objectName + '"]').parent().on('click', "[data-es-action='load']", function() {
            var $this = jQuery(this);
            var $data = $this.find('[data-es-property="data"]');
            if ($data.length) {
                var dataText = $data.text();
                var data = JSON.parse(dataText);

                function linearize(data, prefix, root) {
                    if (!root) {
                        root = data;
                    }

                    if (!prefix) {
                        prefix = '';
                    }

                    for (i in data) {
                        var entry = data[i];
                        if (typeof(entry) == 'object') {
                            linearize(entry, prefix + i + '.', root);
                        } else {
                            root[prefix + i] = entry;
                        }
                    }
                }

                linearize(data);

                for (var i in data) {
                    var $elem = jQuery('.eurosms [data-es-object="' + objectName + '"] :not([data-es-entry]) [data-es-property="' + i + '"]');
                    var $tag = $elem.parent().find('.pstaggerAddTagInput');
                    var entry = data[i];

                    if (entry) {
                        if ($elem.is('[type="checkbox"], [type="radio"]')) {
                            $elem.attr('checked', 1).prop('checked', 1);
                        } else {
                            if ($tag.length) {
                                $tag.val(entry).trigger('change');
                            } else {
                                $elem.val(entry);
                            }
                            if (!$elem.is(':input')) {
                                $elem.text(entry);
                            }
                        }
                    } else {
                        if ($elem.is('[type="checkbox"], [type="radio"]')) {
                            $elem.removeAttr('checked').prop('checked', 0);
                        } else {
                            if ($tag.length) {
                                $tag.val('').trigger('change');
                            } else {
                                $elem.val('');
                            }
                            if (!$elem.is(':input')) {
                                $elem.text('');
                            }
                        }
                    }

                    $elem.trigger('change');
                }
            }

            $this.closest('.modal').find('[data-dismiss="modal"]').click();
        });

        var saveFnc;
        var $save = $this.find("[data-es-action='save']");
        $save.click(saveFnc = function() {
            var valid = true;

            var inpElems = {};
            $editingEntry.find('[data-es-bind]').each(function() {
                var $this = jQuery(this);
                var inpName = $this.attr('data-es-bind');
                var $inp = jQuery('.eurosms [data-es-object="' + objectName + '"] [name="' + inpName + '"]');
                inpElems[inpName] = $inp;
                var val = $inp.val().trim();
                if (!$inp[0].checkValidity() || ($inp.is('[required]') || $inp.is('[data-es-required]')) && (!val || !val.length)) {
                    valid = false;
                    return false;
                } else {
                    $this.text(val);
                }
            });

            if (valid) {
                for (var i in inpElems) {
                    var $inpElem = inpElems[i];
                    $inpElem.attr('data-es-last', $inpElem.val()).val('');
                }
                $editingEntry = null;
                $save.hide();
            } else {
                $editingEntry.attr('data-es-invalid', 1);
            }
        });

        jQuery('.eurosms [data-es-entry="' + objectName + '"]').parent().on('click', "[data-es-action='edit']", function(evt) {
                var $this = jQuery(this);
                var $entry = $this.closest('[data-es-entry]');
                $editingEntry = $entry;

                $entry.find('[data-es-bind]').each(function() {
                    var $this = jQuery(this);
                    var val = $this.text();
                    var inpName = $this.attr('data-es-bind');
                    jQuery('.eurosms [data-es-object="' + objectName + '"] [name="' + inpName + '"]').val(val);
                });

                $save.show();
                evt.stopPropagation();
                return false;
            })
            .on('click', "[data-es-action='delete']", function(evt) {
                var $this = jQuery(this);
                $this.closest('[data-es-entry]').remove();
                $save.hide();
                $editingEntry = null;
                evt.stopPropagation();
                //return false;
            });

    });

    function esAddDataObject(objectName, dataObject, reset) {
        var binds = {};
        if (reset) {
            jQuery('.eurosms [data-es-entry="' + objectName + '"]:not(.template)').remove();
        }

        var $add = jQuery('.eurosms [data-es-object="' + objectName + '"] [data-es-action="add"]');
        for (var i = 0; i < dataObject.length; i++) {
            var dataEntry = dataObject[i];
            for (var j in dataEntry) {
                var $bind = binds[j];
                if (!$bind) {
                    var $prop = jQuery('.eurosms [data-es-entry="' + objectName + '"] [data-es-property="' + j + '"]');
                    var bindName = $prop.attr('data-es-bind');
                    var $bind = jQuery('.eurosms [data-es-object="' + objectName + '"] [name="' + bindName + '"]');
                    binds[j] = $bind;
                }

                var entry = dataEntry[j];
                if (typeof(entry) == 'object') {
                    entry = JSON.stringify(entry);
                }

                $bind.val(entry);
            }

            $add.trigger('click.add');
        }
    }

    if (window.euroSmsDataObjects) {
        for (var objectName in window.euroSmsDataObjects) {
            var dataObject = euroSmsDataObjects[objectName];
            esAddDataObject(objectName, dataObject);
        }
    }

    jQuery('.eurosms form').has('[data-es-object]').submit(function() {
        var dataObjects = {};
        jQuery(".eurosms [data-es-entry]:not(.template)").each(function() {
            var $this = jQuery(this);
            var objectName = $this.attr('data-es-entry');
            if (!dataObjects[objectName]) {
                dataObjects[objectName] = [];
            }

            var dataObject = {};
            dataObjects[objectName].push(dataObject);
            $this.find('[data-es-property]').each(function() {
                var $this = jQuery(this);
                var name = $this.attr('data-es-property');
                var val = $this.text();
                dataObject[name] = val;
            });
        });

        for (var i in dataObjects) {
            var dataObject = dataObjects[i];
            var $input = jQuery('.eurosms [data-es-object="' + i + '"] [name="' + i + '"]');
            $input.val(JSON.stringify(dataObject));
        }
    });

    function esAjax(url, data, callback) {
        jQuery.ajax(url, {
            data: data,
            dataType: 'json',
            processData: false,
            contentType: false,
            method: 'POST',
            success: function(data) {
                callback(data);
            },
            error: function(xhr, status, error) {
                console.error(error);
                alert(error);
            }
        });
    }

    var url = jQuery('.eurosms form').attr('action');

    jQuery('.eurosms #loadTemplate').click(function() {
        var $this = jQuery(this);
        esAjax(url + '&ajax=templateLoad', null, function(response) {
            esAddDataObject('template', response, true);
            jQuery('.eurosms #templateName').val((new Date()).toUTCString().split(',')[1].replace('GMT', '').trim());
        });
    });

    jQuery(".eurosms #template.modal [data-es-action='add']").click(function() {
        var tplName = jQuery('.eurosms #templateName').val() || jQuery('.eurosms #templateName').attr('data-es-last');
        if (!tplName) {
            return;
        }

        var $this = jQuery(this);
        var $form = jQuery('.eurosms form');
        var $ro = $form.find('[readonly]').removeAttr('readonly').prop('readonly', 0);
        var formData = new FormData($form[0]);
        $ro.attr('readonly', 'readonly').prop('readonly', 1);

        /*for(var pair of formData.entries()) {
          console.log(pair[0]+ ', '+ pair[1]); 
        }*/

        formData.append('template', tplName);
        $this.attr('disabled', 'disabled');

        esAjax(url + '&ajax=templateSave', formData, function(response) {
            $this.removeAttr('disabled');
            if (response) {
                console.error(response);
                alert(response);
            }
            jQuery('.eurosms #loadTemplate').triggerHandler('click');
        });
    });

    jQuery(".eurosms #template.modal").on('mousedown touchstart', '[data-es-action="delete"]', function() {
        var $this = jQuery(this);
        var formData = new FormData();
        var dataText = $this.closest('[data-es-entry]').find('[data-es-property="data"]').text();
        var data = JSON.parse(dataText);
        formData.append('id', data['id_euro_sms_notification']);
        esAjax(url + '&ajax=templateDelete', formData, function(response) {
            if (response) {
                console.error(response);
                alert(response);
            }
            jQuery('.eurosms #loadTemplate').triggerHandler('click');
        });
    });

    jQuery('.eurosms #loadFilter').click(function() {
        var $this = jQuery(this);
        esAjax(url + '&ajax=filterLoad', null, function(response) {
            esAddDataObject('filter', response, true);
            jQuery('.eurosms #filterName').val((new Date()).toUTCString().split(',')[1].replace('GMT', '').trim());
        });
    });

    jQuery(".eurosms #filterModal.modal [data-es-action='add']").click(function() {
        if (!window.esFilter) {
            jQuery('.eurosms #loadFilter').triggerHandler('click');
            return;
        }

        var fltName = jQuery('.eurosms #filterName').val() || jQuery('.eurosms #filterName').attr('data-es-last');
        if (!fltName) {
            jQuery('.eurosms #loadFilter').triggerHandler('click');
            return;
        }

        var $this = jQuery(this);
        var formData = new FormData();
        formData.append('name', fltName);
        formData.append('filter', jQuery('.eurosms #filter').val());
        $this.attr('disabled', 'disabled');

        esAjax(url + '&ajax=filterSave', formData, function(response) {
            $this.removeAttr('disabled');
            if (response) {
                console.error(response);
                alert(response);
            }

            jQuery('.eurosms #loadFilter').triggerHandler('click');
        });
    });

    jQuery(".eurosms #filterModal.modal").on('mousedown touchstart', '[data-es-action="delete"]', function() {
        var $this = jQuery(this);
        var formData = new FormData();
        var dataText = $this.closest('[data-es-entry]').find('[data-es-property="data"]').text();
        var data = JSON.parse(dataText);
        formData.append('id', data['id_euro_sms_recipient_filter']);
        esAjax(url + '&ajax=filterDelete', formData, function(response) {
            if (response) {
                console.error(response);
                alert(response);
            }
            jQuery('.eurosms #loadFilter').triggerHandler('click');
        });
    });

    jQuery('.eurosms .cancel').click(function() {
        var $this = jQuery(this);
        var $form = $this.closest('.form');
        $form.find(':input').each(function() {
            var $this = jQuery(this);

            if (!$this.is('[default]')) {
                return;
            }

            var def = $this.attr('default');
            if ($this.is('input[type="checkbox"], input[type="radio"]')) {
                if (parseInt(def)) {
                    $this.attr('checked', 1).prop('checked', 1);
                } else {
                    $this.removeAttr('checked').prop('checked', 0);
                }
            } else if ($this.is('textarea')) {
                $this.val(def).text(def);
            } else if ($this.is('select')) {
                $this.val(def);
            } else {
                $this.val(def);
            }

            $this.trigger('change');
        });
    });

    jQuery('.eurosms [name^="save["]').click(function() {
        var $this = jQuery(this);
        var name = $this.attr('name');
        var formArray = $this.closest('.eurosms form').serializeArray();
        var formData = new FormData();
        name = name.replace('save[', '').replace(']', '');
        var keyPrefix = 'notification[' + name + ']';
        for (var i = 0; i < formArray.length; i++) {
            var formEntry = formArray[i];
            var key = formEntry.name;
            var value = formEntry.value;
            if (key.indexOf(keyPrefix) == 0) {
                var fkey = key.replace(keyPrefix + '[', '').replace(']', '');
                formData.append(fkey, value);
            }
        }

        $this.closest('td').addClass('saving');
        esAjax(url + '&ajax=notificationSave', formData, function(response) {
            $this.closest('td').removeClass('saving');
            if (response) {
                console.error(response);
                alert(response);
            }
        });
    });

    jQuery('.eurosms [id^="active_"]').change(function() {
        var $this = jQuery(this);
        var checked = $this.prop('checked');
        var id = $this.attr('id');
        if (checked) {
            jQuery('.eurosms [id="icon_' + id + '"]').show();
            jQuery('.eurosms [id="icon_not_' + id + '"]').hide();
        } else {
            jQuery('.eurosms [id="icon_' + id + '"]').hide();
            jQuery('.eurosms [id="icon_not_' + id + '"]').show();
        }
    });

    jQuery('.eurosms #filter-operator select').change(function() {
        var $this = jQuery(this);
        var val = $this.val();
        if (val == '<=>') {
            jQuery('.eurosms #filter-dateEnd').addClass('visible').val('');
        }
        else {
            jQuery('.eurosms #filter-dateEnd').removeClass('visible');
        }
    });

    jQuery('.eurosms #filterChoose').change(function() {
        var $this = jQuery(this);
        var val = $this.val();
        jQuery('.eurosms .filter').removeClass('visible');
        if (!val) {
            return;
        }
        var $option = $this.find('option:selected');
        var valObj = JSON.parse(val);
        var input = valObj.input;
        var source = valObj.source;
        if (valObj.range) {
            jQuery('.eurosms #filter-operator-range').show();
        }
        else {
            jQuery('.eurosms #filter-operator-range').hide();
        }

        for (var i = 0; i < input.length; i++) {
            var inp = input[i];
            var $input = jQuery('.eurosms #filter-' + inp).addClass('visible');
            if ($input.find('.input').length) {
                $input = $input.find('.input');
            }
            $input.val($input.attr('default') || '').trigger('change');
            if (source) {
                $input.find('option:not([value=""])').remove('');
                for (var j in source) {
                    var entry = source[j];
                    $input.append('<option value="' + entry.id + '">' + entry.name + '</option>');
                }
            }
        }
    }).find('option').each(function() {
        var $this = jQuery(this);
        $this.attr('data-es-uctext', $this.text().trim().toUpperCase());
    });

    var $filter = jQuery('.eurosms #filter').parent().find('.pstaggerAddTagInput');
    var $filterChoose = jQuery('.eurosms #filterChoose');

    jQuery('.eurosms #apply').click(function() {
        var $this = jQuery(this);
        var choosedVal = $filterChoose.val();
        var choosedText = $filterChoose.find('option:selected').text().trim();
        if (!choosedVal) {
            return;
        }

        var $visibleInputs = jQuery('.eurosms .input:visible');
        var filterVals = [];
        var valid = true;
        $visibleInputs.each(function() {
            var $this = jQuery(this);
            var filterVal = $this.val().trim();
            if (!filterVal) {
                valid = false;
                return false;
            }

            if ($this.parent().is('#filter-operator')) {

            }
            else if ($this.is('select')) {
                var optText = $this.find('option[value="' + filterVal + '"]').text().trim();
                filterVal = optText;
            }

            filterVals.push(filterVal);
        });

        if (!valid) {
            return;
        }

        var addedValue = choosedText.toUpperCase() + ': ' + filterVals.join(' ');
        var filterVal = $filter.val();
        var filterValSplit = filterVal.split(',');
        if (filterValSplit.indexOf(addedValue) > 0) {
            return;
        }

        $filter.val((filterVal ? (filterVal + ',') : '') + addedValue).trigger('change');
    });


    jQuery('.eurosms #filter').change(function() {
        window.esFilter = null;
        var $this = jQuery(this);

        var formData = new FormData();
        var ajaxVal = $filter.val();
        var ajaxValSplit = ajaxVal.split(',');
        var filters = [];
        for (var i = 0; i < ajaxValSplit.length; i++) {
            var ajaxEntry = ajaxValSplit[i];
            var ajaxEntrySplit = ajaxEntry.split(': ');

            var op = ajaxEntrySplit[0].trim();
            var conf = jQuery('.eurosms #filterChoose option[data-es-uctext="' + op + '"]').val();
            if (!conf) {
                continue;
            }

            var confObj = JSON.parse(conf);
            var filter = confObj.filter;
           
            var val = ajaxEntrySplit[1].trim();
            var valSplit = val.split(' ');

            var operator = valSplit[0].trim();
            var value;
            valSplit.shift();

            var value2 = null;
            if (valSplit.length && jQuery('.eurosms #filter-operator option[value="' + operator + '"]').length) {
                if (operator == '<=>') {
                    value = valSplit[0];
                    value2 = valSplit[1];
                }
                else {
                  value = valSplit.join(' ').trim();
                }
            } else {
                value = [operator].concat(valSplit).join(' ');
                operator = null;
            }

            var source = confObj.source;

            var found = false;
            if (source) {
                for (var j in source) {
                    if (source[j].name == value) {
                        value = source[j].id;
                        found = true;
                        break;
                    }
                }

                if (!found) {
                    continue;
                }
            }

            filters.push({
                'filter': filter,
                'operator': operator,
                'value': value,
                'value2': value2
            });
        }

        //console.log(filters);
        window.esFilter = JSON.stringify(filters);
        formData.append('filter', window.esFilter);
        esAjax(url + '&ajax=filterApply', formData, function(response) {
            if (response) {
                if (response.error) {
                    console.error(response.error);
                    alert(error);
                } else {
                    window.esFilteredRecipients = response;
                    esProcessRecipients(window.esFilteredRecipients);
                }
            }
        });
    });

    function esCategorizeByAlphabet(recipients) {
        var categorized = {};
        for (var i in recipients) {
            var recipient = recipients[i];
            var lastname = recipient.lastname;
            var alpha = lastname[0];
            if (!categorized[alpha]) {
                categorized[alpha] = {};
            }

            categorized[alpha][i] = recipient;
        }

        var sorted = {};
        Object.keys(categorized).sort().forEach(function(key) {
            sorted[key] = categorized[key];
        });

        return sorted;
    }

    function esRenderRecipients(recipients, selector) {
        var $elem = jQuery(selector);
        var $table = $elem.find('table');
        var $template = $table.find('.template');
        var $count = $elem.find('.itemCount');
        var $body = $table.find('tbody');

        $body.find('tr:not(.template)').remove();
        window.esRenderingRecipients = true;

        var count = 0;
        for (var alpha in recipients) {
            var recips = recipients[alpha];
            var $tpl = $template.clone().removeClass('template');
            var tplHtml = $tpl.html();
            tplHtml = tplHtml.replace(/\{alpha\}/gi, alpha.toUpperCase());
            var recipArr = [];
            for (var i in recips) {
                var recip = recips[i];
                recipArr.push(recip.firstname + ' ' + recip.lastname.toUpperCase() + ': ' + recip.phone);
            }

            tplHtml = tplHtml.replace(/\{recipients\}/gi, recipArr.join(','));
            $tpl.html(tplHtml);
            $body.append($tpl);
            var $tag = $tpl.find('.pstagger-bar').removeAttr('data-es-noapply');
            pstaggerApply.apply($tag[0]);
            $tag.trigger('change');
            count += recipArr.length;
        }

        window.esRenderingRecipients = false;
        $count.text(count);
    }

    function esProcessRecipients(filteredRecipients, selIncluded, selExcluded) {

        var includedRecipients = {};
        var excludedRecipients = {};

        var allRecipients = window.esAllRecipients;

        for (var i in allRecipients) {
            var allRecipient = allRecipients[i];
            var filteredRecipient = filteredRecipients[i];
            if (filteredRecipient) {
                includedRecipients[i] = allRecipient;
            } else {
                excludedRecipients[i] = allRecipient;
            }
        }

        var catIncludedRecipients = esCategorizeByAlphabet(includedRecipients);
        var catExcludedRecipients = esCategorizeByAlphabet(excludedRecipients);

        esRenderRecipients(catIncludedRecipients, selIncluded || '.eurosms #includedRecipients');
        esRenderRecipients(catExcludedRecipients, selExcluded || '.eurosms #excludedRecipients');
    }

    function esExtractRecipients(recipientStrings, keyedRecipients) {
        var extractedRecipients = {};
        for (var i = 0; i < recipientStrings.length; i++) {
            var recipientString = recipientStrings[i];
            var key = esGetRecipientKey(recipientString);
            var keyedRecipient = keyedRecipients[key];
            if (keyedRecipient) {
                extractedRecipients[keyedRecipient.id] = keyedRecipient;
            }
        }

        return extractedRecipients;
    }

    function esGetRecipientKey(recipient) {
        if (typeof(recipient) == 'object') {
            recipient = (recipient.firstname + ' ' + recipient.lastname + ': ' + recipient.phone);
        }

        return recipient.toLowerCase().replace(/\s/g, '_');
    }

    if (window.esAllRecipients) {
        window.esFilteredRecipients = window.esAllRecipients;
        esProcessRecipients(window.esFilteredRecipients);

        window.esKeyedRecipients = {};
        for (var i in window.esAllRecipients) {
            var allRecipient = window.esAllRecipients[i];
            var key = esGetRecipientKey(allRecipient);
            window.esKeyedRecipients[key] = allRecipient;
        }

        jQuery('.eurosms #includedRecipients').on('change', '[name="included[]"]:not([data-es-noapply])', function() {
            if (window.esRenderingRecipients) {
                return;
            }
            var recipientStrings = [];
            jQuery('.eurosms #includedRecipients [name="included[]"]:not([data-es-noapply])').each(function() {
                var $this = jQuery(this);
                var val = $this.val();
                if (val) {
                    recipientStrings = recipientStrings.concat(val.split(','));
                }
            });

            var extractedRecipients = esExtractRecipients(recipientStrings, window.esKeyedRecipients);
            esProcessRecipients(extractedRecipients);
        });

        jQuery('.eurosms #excludedRecipients').on('change', '[name="excluded[]"]:not([data-es-noapply])', function() {
            if (window.esRenderingRecipients) {
                return;
            }
            var recipientStrings = [];
            jQuery('.eurosms #excludedRecipients [name="excluded[]"]:not([data-es-noapply])').each(function() {
                var $this = jQuery(this);
                var val = $this.val();
                if (val) {
                    recipientStrings = recipientStrings.concat(val.split(','));
                }
            });
   
            var extractedRecipients = esExtractRecipients(recipientStrings, window.esKeyedRecipients);
            var includedRecipients = {};
            for (var i in window.esAllRecipients) {
                if (!extractedRecipients[i]) {
                    includedRecipients[i] = window.esAllRecipients[i];
                }
            }

            esProcessRecipients(includedRecipients);
        });
    }

    jQuery('.eurosms form[name="eurosms_marketing"]').submit(function(evt) {
        var $included = jQuery('.eurosms [name="included[]"]:not([data-es-noapply])');
        var $recipients = jQuery('.eurosms #recipients');
        var recipients = [];
        $included.each(function() {
            var $this = jQuery(this);
            var val = $this.val();
            var valSplit = val.split(',');
            for (var i = 0; i < valSplit.length; i++) {
                var valEntry = valSplit[i];
                var valEntrySplit = valEntry.split(':');
                var recipient = valEntrySplit.pop().trim();
                recipients.push(recipient);
            }
        });

        $recipients.val(recipients.join(' '));
    });

    jQuery('[id^="storeSelect"]').attr('readonly', 'readonly').prop('readonly', true).css('pointer-events', 'none');
});